/***************************************************************************
                          editor.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "editor.h"
#include "auriferous.h"
#include "menu.h"
#include "config.h"
#include "timer.h"
#include "wheel.h"
#include "button.h"
#include "jukebox.h"

#ifdef WIN32
static CL_String custom_path="";
#else
static CL_String custom_path=(CL_String)(getenv("HOME"))+"/.auriferous/";
#endif

Editor::Editor(Auriferous* _app)
{
	app=_app;

  timer=new Timer;
  Config::set_last_levelset("custom");
  Config::read_maxl();

  wh=new Wheel(50, 736, app->menu, Config::get_maxl(), 1); //I think 10000 levels are enough, aren't it :)
  load=new Button(140, 736, app->menu, "Load");
  save=new Button(240, 736, app->menu, "Save");
  add=new Button(340, 736, app->menu, "New");
  sworld=new Button(440, 736, app->menu, "World");

  this->reset();
}
void Editor::reset()
{
  if(menu==2 || menu==3)
  ok->set_Delete_Me();
  if(menu==2 || menu==3)
  wh1->set_Delete_Me();
  if(menu==2)
  wh2->set_Delete_Me();

  for(int x=0; x<30; ++x)
  {
    for(int y=0; y<21; ++y)
    {
      Turflayer[x][y]=" ";  //set to an EMPTY
      Toollayer[x][y]=""; //no tools
    }
  }
  pencil="N00";
  wt=AQUA;
  adjust_world();
  turf=true;
  menu=0;
  c=false;
}
Editor::~Editor()
{
}
void Editor::run()
{
	while(CL_Keyboard::get_keycode(CL_KEY_ESCAPE) != true)
	{
		CL_Display::clear_display();
    act();
    draw_map();
    draw_gui();

		if(Config::get_fps()==true)
		app->menu->draw_fps();

		app->menu->actshowgui();
		CL_Display::flip_display();			
		CL_System::keep_alive();
	}

  if(menu==2 || menu==3)
  ok->set_Delete_Me();
  if(menu==2 || menu==3)
  wh1->set_Delete_Me();
  if(menu==2)
  wh2->set_Delete_Me();

  add->set_Delete_Me();
  save->set_Delete_Me();
  load->set_Delete_Me();
  wh->set_Delete_Me();

  Config::set_last_level(wh->get_val());
}

void Editor::draw_gui()
{
  Resources::Gameframe()->put_screen(0, 0);

  if(menu==1)
  Resources::Rfontg()->print_left(100, 0, "Click on the Monk respawn pos!");
  else if(menu==2)
  Resources::Rfontg()->print_left(480, 295, "id:   dest:");
  else if(menu==3)
  Resources::Rfontg()->print_left(480, 295, "time:");

  Resources::Monk()->put_screen(536, 744, 0.75f, 0.75f, 0);
  sur->put_screen(560, 720, 0.75f, 0.75f, 0);
  sur->put_screen(560, 744, 0.75f, 0.75f, 40);
  sur->put_screen(584, 720, 0.75f, 0.75f, 48);
  sur->put_screen(584, 744, 0.75f, 0.75f, 56);
  sur->put_screen(608, 720, 0.75f, 0.75f, 0);
  Resources::Tiles()->put_screen(608, 720, 0.75f, 0.75f, 42);
  sur->put_screen(608, 744, 0.75f, 0.75f, 0);
  Resources::Arrows()->put_screen(608, 744, 0.75f, 0.75f, 3);
  sur->put_screen(632, 720, 0.75f, 0.75f, 72);
  sur->put_screen(632, 720, 0.75f, 0.75f, 64);
  Resources::Tiles()->put_screen(632, 744, 0.75f, 0.75f, 42);
  sur->put_screen(656, 720, 0.75f, 0.75f, 40);
  Resources::Arrows()->put_screen(656, 720, 0.75f, 0.75f, 5);
  sur->put_screen(656, 744, 0.75f, 0.75f, 43);
  Resources::Tiles()->put_screen(680, 720, 0.75f, 0.75f, 43);
  Resources::Tiles()->put_screen(680, 744, 0.75f, 0.75f, 81);
  Resources::Tiles()->put_screen(704, 720, 0.75f, 0.75f, 0);
  Resources::Tiles()->put_screen(704, 744, 0.75f, 0.75f, 12);
  Resources::Tiles()->put_screen(728, 720, 0.75f, 0.75f, 24);
  Resources::Tiles()->put_screen(728, 744, 0.75f, 0.75f, 28);
  Resources::Player()->put_screen(752, 720, 0.75f, 0.75f, 0);
  Resources::Playerr()->put_screen(752, 744, 0.75f, 0.75f, 0);

  Resources::Tiles()->put_screen(776, 720, 0.75f, 0.75f, 63);
  Resources::Tiles()->put_screen(776, 744, 0.75f, 0.75f, 64);
  Resources::Tiles()->put_screen(800, 720, 0.75f, 0.75f, 65);
  Resources::Tiles()->put_screen(800, 744, 0.75f, 0.75f, 48);
  Resources::Tiles()->put_screen(824, 720, 0.75f, 0.75f, 49);
  Resources::Tiles()->put_screen(824, 744, 0.75f, 0.75f, 50);
  Resources::Tiles()->put_screen(848, 720, 0.75f, 0.75f, 51);
  Resources::Tiles()->put_screen(848, 744, 0.75f, 0.75f, 52);
  Resources::Tiles()->put_screen(872, 720, 0.75f, 0.75f, 53);
  Resources::Tiles()->put_screen(872, 744, 0.75f, 0.75f, 54);
  Resources::Tiles()->put_screen(896, 720, 0.75f, 0.75f, 55);
  Resources::Tiles()->put_screen(896, 744, 0.75f, 0.75f, 56);
  Resources::Tiles()->put_screen(920, 720, 0.75f, 0.75f, 57);
  Resources::Tiles()->put_screen(920, 744, 0.75f, 0.75f, 58);
  Resources::Tiles()->put_screen(944, 720, 59);
  Resources::Tiles()->put_screen(944, 744, 0.75f, 0.75f, 66);
  Resources::Tiles()->put_screen(968, 720, 0.75f, 0.75f, 67);
  Resources::Tiles()->put_screen(968, 744, 0.75f, 0.75f, 68);
}
void Editor::act()
{
  if(add->is_pressed())
  {
    reset();
    Config::read_maxl();
    wh->set_val(Config::get_maxl()+1);
    wh->set_max(Config::get_maxl()+1);
  }
  if(save->is_pressed())
  {
    this->save_map();
  }
  if(load->is_pressed())
  {
    this->load_map();
  }
  if(sworld->is_pressed())
  {
    int i=(int)(wt);

    if(i==4)
    i=0;
    else
    i++;

    wt=(WorldType)(i);

    adjust_world();
  }

  if(timer->time_elapsed()>=0.5f)
  {
  if(menu==0) {
    if(CL_Mouse::left_pressed())
    {
      this->select();
      this->paint();
    }
    else if(CL_Mouse::right_pressed())
    {
      this->erase();
    }
    else if(CL_Mouse::middle_pressed())
    {
      if(CL_Mouse::get_x()>32 && CL_Mouse::get_x()<992 && CL_Mouse::get_y()>32 && CL_Mouse::get_y()<704)
      {
        if(Toollayer[(CL_Mouse::get_x()/32)-1][(CL_Mouse::get_y()/32)-1].find(110, 0)!=-1) //monk
        menu=1;
        else if(Turflayer[(CL_Mouse::get_x()/32)-1][(CL_Mouse::get_y()/32)-1].find(84, 0)!=-1)  //tele
        menu=2;
        else if(Turflayer[(CL_Mouse::get_x()/32)-1][(CL_Mouse::get_y()/32)-1].find(77, 0)!=-1)  //move
        menu=3;

        mx=(CL_Mouse::get_x()/32)-1;
        my=(CL_Mouse::get_y()/32)-1;
      }
    }
  }
  else if(menu==1)
  {
    if(CL_Mouse::left_pressed() && CL_Mouse::get_x()>32 && CL_Mouse::get_x()<992 && CL_Mouse::get_y()>32 && CL_Mouse::get_y()<704)
    {
      int x=(CL_Mouse::get_x()/32)-1;
      int y=(CL_Mouse::get_y()/32)-1;
      CL_String str="n";
      Toollayer[mx][my]=str+x+","+y+",";
      menu=0;
      timer->reset();
    }
  }
  else if(menu==2)
  {
    if(!c)
    {
      ok=new Button(500, 416, app->menu, "OK");
      wh1=new Wheel(480, 352, app->menu, 630, 1);
      wh2=new Wheel(544, 352, app->menu, 630, 1);
      c=true;
    }
    if(ok->is_pressed())
    {
      CL_String str="T";
      Turflayer[mx][my]=str+wh1->get_val()+","+wh2->get_val()+",";

      menu=0;
      timer->reset();
      ok->set_Delete_Me();
      wh1->set_Delete_Me();
      wh2->set_Delete_Me();
      c=0;
    }
  }
  else if(menu==3)
  {
    if(!c)
    {
      ok=new Button(500, 416, app->menu, "OK");
      wh1=new Wheel(480, 352, app->menu, 630, 1);
      c=true;
    }
    if(ok->is_pressed())
    {
      CL_String str="M";
      Turflayer[mx][my]=str+(wh1->get_val()-1)+",";

      menu=0;
      timer->reset();
      ok->set_Delete_Me();
      wh1->set_Delete_Me();
      c=0;
    }
  }
  }
}
void Editor::draw_map()
{
  bg->put_screen(32, 32);

  for(int x=0; x<30; ++x)
  {
    for(int y=0; y<21; ++y)
    {
      if(Turflayer[x][y]==" ")
      ;
      else if(Turflayer[x][y]=="N00")
      sur->put_screen(32+(x*32), 32+(y*32), 0);
      else if(Turflayer[x][y]=="N10")
      {
        sur->put_screen(32+(x*32), 32+(y*32), 0);
        Resources::Arrows()->put_screen(32+(x*32), 32+(y*32), 3);
      }
      else if(Turflayer[x][y]=="N01")
      {
        sur->put_screen(32+(x*32), 32+(y*32), 0);
        Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 42);
      }
      else if(Turflayer[x][y]=="B")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 43);
      else if(Turflayer[x][y]=="C")
      sur->put_screen(32+(x*32), 32+(y*32), 40);
      else if(Turflayer[x][y]=="H")
      sur->put_screen(32+(x*32), 32+(y*32), 56);
      else if(Turflayer[x][y]=="S")
      sur->put_screen(32+(x*32), 32+(y*32), 48);
      else if(Turflayer[x][y]=="W")
      {
        sur->put_screen(32+(x*32), 32+(y*32), 72);
        sur->put_screen(32+(x*32), 32+(y*32), 64);
      }
      else if(Turflayer[x][y]=="O")
      sur->put_screen(32+(x*32), 32+(y*32), 43);
      else if(Turflayer[x][y]=="L0")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 42);
      else if(Turflayer[x][y]=="L1")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 81);
      else if(Turflayer[x][y]=="D0")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 24);
      else if(Turflayer[x][y]=="D1")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 12);
      else if(Turflayer[x][y]=="D2")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 0);
      else if(Turflayer[x][y].find(84, 0)!=-1)  //tele
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 28);
      else if(Turflayer[x][y].find(77, 0)!=-1)  //move
      {
        sur->put_screen(32+(x*32), 32+(y*32), 40);
        Resources::Arrows()->put_screen(32+(x*32), 32+(y*32), 5);
      }

      if(Toollayer[x][y]=="g0")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 63);
      else if(Toollayer[x][y]=="g1")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 64);
      else if(Toollayer[x][y]=="g2")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 65);
      else if(Toollayer[x][y]=="k1")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 49);
      else if(Toollayer[x][y]=="k0")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 51);
      else if(Toollayer[x][y]=="b0")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 66);
      else if(Toollayer[x][y]=="b1")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 67);
      else if(Toollayer[x][y]=="b2")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 68);
      else if(Toollayer[x][y]=="p")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 54);
      else if(Toollayer[x][y]=="i")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 48);
      else if(Toollayer[x][y]=="j")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 56);
      else if(Toollayer[x][y]=="x")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 52);
      else if(Toollayer[x][y]=="s")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 50);
      else if(Toollayer[x][y]=="l")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 53);
      else if(Toollayer[x][y]=="y")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 57);
      else if(Toollayer[x][y]=="a")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 59);
      else if(Toollayer[x][y]=="t")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 55);
      else if(Toollayer[x][y]=="m")
      Resources::Tiles()->put_screen(32+(x*32), 32+(y*32), 58);
      else if(Toollayer[x][y]=="P0")
      Resources::Player()->put_screen(32+(x*32), 32+(y*32), 0);
      else if(Toollayer[x][y]=="P1")
      Resources::Playerr()->put_screen(32+(x*32), 32+(y*32), 0);
      else if(Toollayer[x][y].find(110, 0)!=-1) //monk
      Resources::Monk()->put_screen(32+(x*32), 32+(y*32), 0);
    }
  }
}
void Editor::adjust_world()
{
	switch(wt)
	{
	  case AQUA: bg=Resources::Abackground(); sur=Resources::Atile(); break;
	  case ICE: bg=Resources::Ibackground(); sur=Resources::Itile();  break;
	  case LAVA: bg=Resources::Lbackground(); sur=Resources::Ltile();  break;
	  case JUNGLE: bg=Resources::Jbackground(); sur=Resources::Jtile();  break;
	  case TECH: bg=Resources::Tbackground(); sur=Resources::Ttile();  break;
	}
  Jukebox::init(wt);
}
void Editor::select()
{
  if(CL_Mouse::get_x()>536 && CL_Mouse::get_x()<560 && CL_Mouse::get_y()>744 && CL_Mouse::get_y()<768)
  {
    pencil="n0,0,";
    turf=false;
  }
  else if(CL_Mouse::get_x()>536 && CL_Mouse::get_x()<992 && CL_Mouse::get_y()>720 && CL_Mouse::get_y()<768)
  {
    if(CL_Mouse::get_y()<744)
    {
      if(CL_Mouse::get_x()<584)
      pencil="N00";
      else if(CL_Mouse::get_x()<608)
      pencil="S";
      else if(CL_Mouse::get_x()<632)
      pencil="N01";
      else if(CL_Mouse::get_x()<656)
      pencil="W";
      else if(CL_Mouse::get_x()<680)
      pencil="M0,";
      else if(CL_Mouse::get_x()<704)
      pencil="B";
      else if(CL_Mouse::get_x()<728)
      pencil="D2";
      else if(CL_Mouse::get_x()<752)
      pencil="D0";
      else if(CL_Mouse::get_x()<776)
      pencil="P0";
      else if(CL_Mouse::get_x()<800)
      pencil="g0";
      else if(CL_Mouse::get_x()<824)
      pencil="g2";
      else if(CL_Mouse::get_x()<848)
      pencil="k1";
      else if(CL_Mouse::get_x()<872)
      pencil="k0";
      else if(CL_Mouse::get_x()<896)
      pencil="l";
      else if(CL_Mouse::get_x()<920)
      pencil="t";
      else if(CL_Mouse::get_x()<944)
      pencil="y";
      else if(CL_Mouse::get_x()<968)
      pencil="a";
      else if(CL_Mouse::get_x()<992)
      pencil="b1";
    }
    else
    {
      if(CL_Mouse::get_x()<584)
      pencil="C";
      else if(CL_Mouse::get_x()<608)
      pencil="H";
      else if(CL_Mouse::get_x()<632)
      pencil="N10";
      else if(CL_Mouse::get_x()<656)
      pencil="L0";
      else if(CL_Mouse::get_x()<680)
      pencil="O";
      else if(CL_Mouse::get_x()<704)
      pencil="L1";
      else if(CL_Mouse::get_x()<728)
      pencil="D1";
      else if(CL_Mouse::get_x()<752)
      pencil="T1,1,";
      else if(CL_Mouse::get_x()<776)
      pencil="P1";
      else if(CL_Mouse::get_x()<800)
      pencil="g1";
      else if(CL_Mouse::get_x()<824)
      pencil="i";
      else if(CL_Mouse::get_x()<848)
      pencil="s";
      else if(CL_Mouse::get_x()<872)
      pencil="x";
      else if(CL_Mouse::get_x()<896)
      pencil="p";
      else if(CL_Mouse::get_x()<920)
      pencil="j";
      else if(CL_Mouse::get_x()<944)
      pencil="m";
      else if(CL_Mouse::get_x()<968)
      pencil="b0";
      else if(CL_Mouse::get_x()<992)
      pencil="b2";
    }

    if(CL_Mouse::get_x()>752)
    turf=false;
    else
    turf=true;
  }
}
void Editor::paint()
{
  if(CL_Mouse::get_x()>32 && CL_Mouse::get_x()<992 && CL_Mouse::get_y()>32 && CL_Mouse::get_y()<704) {
    if(turf)
    {
      Turflayer[(CL_Mouse::get_x()/32)-1][(CL_Mouse::get_y()/32)-1]=pencil;
      Toollayer[(CL_Mouse::get_x()/32)-1][(CL_Mouse::get_y()/32)-1]="";
    }
    else
    {
      if(pencil=="P0")
      {
        for(int x=0; x<30; ++x)
        {
          for(int y=0; y<21; ++y)
          {
            if(Toollayer[x][y]=="P0")
            Toollayer[x][y]="";
          }
        }
      }
      else if(pencil=="P1")
      {
        for(int x=0; x<30; ++x)
        {
          for(int y=0; y<21; ++y)
          {
            if(Toollayer[x][y]=="P1")
            Toollayer[x][y]="";
          }
        }
      }

      Toollayer[(CL_Mouse::get_x()/32)-1][(CL_Mouse::get_y()/32)-1]=pencil;
    }
  }

}
void Editor::erase()
{
  if(CL_Mouse::get_x()>32 && CL_Mouse::get_x()<992 && CL_Mouse::get_y()>32 && CL_Mouse::get_y()<704)
  {
    Turflayer[(CL_Mouse::get_x()/32)-1][(CL_Mouse::get_y()/32)-1]=" ";
    Toollayer[(CL_Mouse::get_x()/32)-1][(CL_Mouse::get_y()/32)-1]="";
  }

}
void Editor::save_map()
{
  CL_String filename=custom_path+"levels/custom/level"+(wh->get_val()-1)+".lvl";
  ofstream out(filename.get_string());

  out<<(int)(wt)<<endl<<"0"<<endl;

  for(int y=0; y<21; ++y)
  {
    for(int x=0; x<30; ++x)
    {
      out<<Toollayer[x][y]<<Turflayer[x][y];
    }
    out<<endl;
  }
}
void Editor::load_map()
{
  reset();

	CL_String mapfile="";

	mapfile=custom_path+"levels/custom/level"+(wh->get_val()-1)+".lvl";

	ifstream in(mapfile.get_string());
	char last;
	CL_String a;
	int x=0, y=-1, c=-1, w=0;

  in>>w;
  in>>c;


  if(c==-1)
  return;

  wt=(WorldType)(w);
  adjust_world();

	while(!in.eof())
	{
		last=in.get();
		char buf[2];
		buf[0]=last;
		buf[1]=0;
		a=buf;

		if(!in.eof())
		{
			if(last==10)
			{
			  y++;
			  x=0;
      }
		}

		if(a=="g")
		{
			int t=0;

			last=in.get();

			t+=last;
			t=t-48;

			Toollayer[x][y]=a+t;
		}
		else if(a=="k")
		{
			int t=0;

			last=in.get();

			t+=last;
			t=t-48;

			Toollayer[x][y]=a+t;
		}
		else if(a=="b")
		{
			int t=0;

			last=in.get();
			t+=last;
			t=t-48;

		  Toollayer[x][y]=a+t;
		}
		else if(a=="n")
		{
			int dx=0;
			int dy=0;

			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					dx=dx*10;
					dx+=last;
					dx=dx-48;
				}
			}

			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					dy=dy*10;
					dy+=last;
					dy=dy-48;
				}
			}
			Toollayer[x][y]=a+dx+","+dy+",";
		}
		else if(a=="p")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="i")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="j")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="x")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="s")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="l")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="y")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="a")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="t")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="m")
		{
			Toollayer[x][y]=a;
		}
		else if(a=="B")
		{
			Turflayer[x][y]=a;
			x++;
		}
		else if(a=="C")
		{
			Turflayer[x][y]=a;
			x++;
		}
		else if(a=="H")
		{
			Turflayer[x][y]=a;
			x++;
		}
		else if(a=="S")
		{
			Turflayer[x][y]=a;
			x++;
		}
		else if(a=="W")
		{
			Turflayer[x][y]=a;
			x++;
		}
		else if(a=="O")
		{
			Turflayer[x][y]=a;
			x++;
		}
		else if(a==" ")
		{
			Turflayer[x][y]=a;
			x++;
		}
		else if(a=="L")
		{
			last=in.get();
			bool hidden=false;
			if(last==49)
			hidden=true;

			Turflayer[x][y]=(CL_String)(a)+(CL_String)(hidden);
			x++;
		}
		else if(a=="N")
		{
			bool falling=false;
			bool ladder=false;

			last=in.get();
			if(last==49)
			falling=true;

			last=in.get();
			if(last==49)
			ladder=true;

			Turflayer[x][y]=(CL_String)(a)+(CL_String)(falling)+(CL_String)(ladder);
			x++;
		}
		else if(a=="M")
		{
			int time=0;
			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					time=time*10;
					time+=last;
					time=time-48;
				}
			}
			Turflayer[x][y]=a+time+",";
			x++;
		}
		else if(a=="T")
		{
			int dest=0;
			int tid=0;

			last=0;
			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					tid=tid*10;
					tid+=last;
					tid=tid-48;
				}
			}
			
			last=0;
			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					dest=dest*10;
					dest+=last;
					dest=dest-48;
				}
			}
			Turflayer[x][y]=a+tid+","+dest+",";
			x++;
		}
		else if(a=="D")
		{
			int dtype=0;

			last=in.get();
			dtype+=last;
			dtype=dtype-48;

			Turflayer[x][y]=a+dtype;
			x++;
		}
		else if(a=="P")
		{
			int id=0;
			last=in.get();
			id+=last;
			id=id-48;

			Toollayer[x][y]=a+id;
  	}
  }
}